<template>
  <section class="audio-player">
    <v-card dark class="audio-player__wrapper" :class="{ 'audio-player_compact': compact }">
      <v-btn icon flat small @click="play" :disabled="recording" class="audio-player__play">
        <v-icon>{{getAudioIcon(recording, playing)}}</v-icon>
        <audio
          :src="src"
          ref="player"
          preload="auto"
          @ended="onAudioEnd"
          @loadeddata="onLoaded"
          @timeupdate="onTimeUpdate"
        />
      </v-btn>
      <audio-current-time
        :current-time="currentTime"
        :progress-status="progressStatus"
        :total-duration="totalDuration"
      />
      <v-btn icon flat small @click="mute">
        <v-icon v-if="muted">volume_off</v-icon>
        <v-icon v-else>volume_up</v-icon>
      </v-btn>
    </v-card>
  </section>
</template>
<style lang="sass" scoped>
  .audio-player
    padding: 30px 0px
    width: 100%
    &_compact
      min-height: 30px
      font-size: 0.8em
    &__wrapper
      display: flex
      width: 100%
      min-width: 200px
      min-height: 40px
      background: #2d2e78!important
</style>

<script>
import AudioCurrentTime from './components/AudioCurrentTime';
import AudioHelper from './helpers/index';

export default {
  components: {
    AudioCurrentTime,
  },
  props: {
    src: { required: true },
    compact: Boolean,
    recording: Boolean,
  },
  data() {
    return {
      playing: false,
      muted: false,
      audioPlayer: {},
      totalDuration: '00:00',
      currentTime: '00:00',
      progressStyle: '',
      progressStatus: 0,
      lastPlay: new Date(),
    };
  },
  methods: {
    getAudioIcon: AudioHelper.getAudioIcon,
    play() {
      const timeDiff = new Date().getTime() - this.lastPlay.getTime();
      if (timeDiff < 400) return;
      this.lastPlay = new Date();
      if (this.playing) {
        this.$refs.player.pause();
        this.playing = false;
      } else {
        const play = this.$refs.player.play();
        play.then(() => {
          this.playing = true;
        });
      }
      this.$emit('playing-change', this.playing);
    },
    mute() {
      this.muted = !this.muted;
      this.$refs.player.muted = this.muted;
    },
    onAudioEnd() {
      this.playing = false;
      this.progressStatus = 100;
      this.$emit('playing-change', this.playing);
    },
    onLoaded({ target }) {
      this.totalDuration = AudioHelper.convertTimeHHMMSS(target.duration);
    },
    onTimeUpdate({ target }) {
      const currTime = parseInt(target.currentTime, 10);
      const percentage = parseInt((currTime / target.duration) * 100, 10);
      this.progressStatus = percentage || 0;
      this.currentTime = AudioHelper.convertTimeHHMMSS(currTime);
    },
  },
};
</script>
